#include <cassert>
#include <cmath>

#include "Fibonacci.h"

long Fibonacci::_COST = 0L;

const double Fibonacci::Golden_number = (1. + ::sqrt(5.)) / 2.;

Fibonacci::Fibonacci(long n, Method method) : result(method == Method::Recursive ? _recursive(n) : method == Method::Iterative ? _iterative(n) : _binet(n)) {
	cost = _COST;
	_COST = 0L;
}

long Fibonacci::_recursive(long n) const {
	assert(n >= 0L);
	if (n == 0L) return 0L;
	if (n == 1L) return 1L;
	_COST++;
	return _recursive(n - 1L) + _recursive(n - 2L);
}

long Fibonacci::_iterative(long n) const {
	assert(n >= 0L);
	if (n == 0L) return 0L;
	if (n == 1L) return 1L;
	long u = 1L, v = 0L, u0, v0;
	for (long i = 2L; i <= n; i++) {
		_COST++;
		u0 = u;
		v0 = v;
		u = u0 + v0;
		v = u0;
	}
	return u;
}

long Fibonacci::_binet(long n) const {
	assert(n >= 0L);
	return long((::pow(Golden_number, double(n)) - ::pow((1. - Golden_number), double(n))) / ::sqrt(5.));
}